﻿using System;
using System.Windows.Forms;
using GTA;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;

public class text : Script
{
    string input = "####"; // 入力用

    Font myFont;

    const float spaceX = 0.072f;
    const float spaceY = 0.28f;
    int itemMaxCount = 20;
    int[] itemCount;
    int itemListY;

    bool textCheck = false;
    bool showText;
    bool gameKeyPress;
    int titleLengthX;
    int titleLengthY;
    int textLengthX;
    int textLengthY;
    int selectedIndex;
    int selectedPage;
    int pageNumber;

    string[] textPath;
    string[] textTitle;
    string[] textText;

    public text()
    {
        Interval = 0;

        myFont = new Font();
        myFont.Color = System.Drawing.Color.White;
        myFont.FixedLetterWidth = true;
        myFont.Style = FontStyle.ThinAllUpper;
        myFont.Height = 0.3f;

        Tick += new EventHandler(text_Tick);
        KeyDown += new GTA.KeyEventHandler(text_KeyDown);
        PerFrameDrawing += new GraphicsEventHandler(text_PerFrameDrawing);
    }

    void text_Tick(object sender, EventArgs e)
    {
        if (textCheck == true)
        {
            if (Game.isGameKeyPressed(GameKey.MoveForward) || Game.isGameKeyPressed(GameKey.MoveBackward) || Game.isGameKeyPressed(GameKey.MoveRight) || Game.isGameKeyPressed(GameKey.MoveLeft) || Game.isGameKeyPressed(GameKey.Sprint) || Game.isGameKeyPressed(GameKey.EnterCar))
            {
                if (gameKeyPress == false)
                {
                    gameKeyPress = true;
                    //メニュー操作
                    if (showText == false)
                    {
                        if (Game.isGameKeyPressed(GameKey.MoveForward))
                        {
                            selectedIndex -= 1;
                        }
                        else if (Game.isGameKeyPressed(GameKey.MoveBackward))
                        {
                            selectedIndex += 1;
                        }
                        else if (Game.isGameKeyPressed(GameKey.MoveRight))
                        {
                            selectedPage += 1;
                        }
                        else if (Game.isGameKeyPressed(GameKey.MoveLeft))
                        {
                            selectedPage -= 1;
                        }

                        //selectedPageを右から左、左から右へ
                        if (selectedPage < 0)
                        {
                            selectedPage = pageNumber - 1;
                        }
                        else if (selectedPage > pageNumber - 1)
                        {
                            selectedPage = 0;
                        }

                        //selectedIndexを上から下、下から上へ
                        if (selectedIndex < 0)
                        {
                            selectedIndex = itemListY - 1;
                        }
                        else if (selectedIndex >= itemListY)
                        {
                            selectedIndex = 0;
                        }

                        //開く
                        if (Game.isGameKeyPressed(GameKey.Sprint))
                        {
                            LoadText();
                        }
                        else if (Game.isGameKeyPressed(GameKey.EnterCar))
                        {
                            textCheck = false;
                        }
                    }
                    else
                    {
                        if (Game.isGameKeyPressed(GameKey.EnterCar))
                        {
                            showText = false;
                        }
                    }
                }
            }
            else
            {
                gameKeyPress = false;
            }
        }
    }

    void text_PerFrameDrawing(object sender, GraphicsEventArgs e)
    {
        if (textCheck == true)
        {
            //項目
            if (showText == false)
            {
                //背景
                e.Graphics.DrawRectangle(spaceX + titleLengthX * 0.00585f, spaceY + (itemListY + 2) * 0.01f, titleLengthX * 0.0117f, (itemListY + 2) * 0.02f, System.Drawing.Color.FromArgb(128, 0, 0, 0));

                //選択バー
                e.Graphics.DrawRectangle(spaceX + titleLengthX * 0.00585f, spaceY + selectedIndex * 0.02f + 0.03f, titleLengthX * 0.0117f, 0.02f, System.Drawing.Color.FromArgb(64, 255, 255, 255));

                //タイトル
                myFont.Alignment = TextAlignment.Centered;
                e.Graphics.DrawText(spaceX + titleLengthX * 0.00585f, spaceY, "-text_reader-", myFont);

                //テキストリスト
                myFont.Alignment = TextAlignment.Left;
                for (int i = 0; i < itemCount[selectedPage]; i++)
                {
                    e.Graphics.DrawText(spaceX, spaceY + (i + 1) * 0.02f, textTitle[i + selectedPage * itemListY], myFont);
                }

                //ページ数
                myFont.Alignment = TextAlignment.Centered;
                e.Graphics.DrawText(spaceX + titleLengthX * 0.00585f, spaceY + (itemListY + 1) * 0.02f, "page_" + (selectedPage + 1) + "_/_" + (pageNumber), myFont);
            }
            else
            {
                //背景
                e.Graphics.DrawRectangle(spaceX + textLengthX * 0.00585f, spaceY + (textLengthY + 1) * 0.01f, textLengthX * 0.0117f, (textLengthY + 1) * 0.02f, System.Drawing.Color.FromArgb(128, 0, 0, 0));

                //タイトル
                myFont.Alignment = TextAlignment.Centered;
                e.Graphics.DrawText(spaceX + textLengthX * 0.00585f, spaceY, "-" + textTitle[selectedIndex + selectedPage * itemCount[0]] + "-", myFont);

                //テキスト
                myFont.Alignment = TextAlignment.Left;
                for (int i = 0; i < textLengthY; i++)
                {
                    e.Graphics.DrawText(spaceX, spaceY + (i + 1) * 0.02f, textText[i], myFont);
                }
            }
        }
    }

    void GetItem()
    {
        if (Directory.Exists(Path.GetDirectoryName(Application.ExecutablePath) + @"\scripts\text") == true)
        {
            textPath = Directory.GetFiles(Path.GetDirectoryName(Application.ExecutablePath) + @"\scripts\text");
            textTitle = new string[textPath.Length];

            for (int i = 0; i < textPath.Length; i++)
            {
                textTitle[i] = Path.GetFileName(textPath[i]);

                if (textTitle[i].Length > titleLengthX)
                {
                    titleLengthX = textTitle[i].Length;
                }
            }

            titleLengthY = textPath.Length;

            if (titleLengthY > 0)
            {
                //ページ数
                pageNumber = (titleLengthY - 1) / itemMaxCount + 1;

                //アイテムリストの長さ
                itemListY = (titleLengthY - 1) / pageNumber + 1;
            }
            else
            {
                pageNumber = 1;
                itemListY = 1;
            }

            //ページ別項目数
            itemCount = new int[pageNumber];
            for (int i = 0; i < pageNumber; i++)
            {
                if (i == pageNumber - 1)
                {
                    itemCount[i] = titleLengthY - itemListY * i;
                }
                else
                {
                    itemCount[i] = itemListY;
                }
            }
        }
        else
        {
            Game.DisplayText(@"""scripts\text"" directory don't found.");
        }
    }

    void LoadText()
    {
        if (titleLengthY > selectedIndex + selectedPage * itemListY)
        {
            try
            {
                StreamReader reader = new StreamReader(textPath[selectedIndex + selectedPage * itemListY], Encoding.GetEncoding("Shift_JIS"));
                string readData = reader.ReadToEnd();
                reader.Close();

                int length = 0;
                int maxLength = (int)((1.0 - spaceX * 2.0) / 0.0117);
                string[] temp2 = readData.Replace("\r", "").Split(new char[] { '\n' });
                foreach (string temp in temp2)
                {
                    if (temp.Length > 0)
                    {
                        length += (temp.Length - 1) / maxLength + 1;
                    }
                    else
                    {
                        length++;
                    }
                }
                textText = new string[length];
                int j = 0;
                int temp3;
                foreach (string temp in temp2)
                {
                    if (temp.Length > maxLength)
                    {
                        temp3 = (temp.Length - 1) / maxLength + 1;
                        for (int k = 0; k < temp3; k++)
                        {
                            if (k == temp3 - 1)
                            {
                                textText[j] = temp.Substring(k * maxLength);
                            }
                            else
                            {
                                textText[j] = temp.Substring(k * maxLength, maxLength - 1);
                            }
                            j++;
                        }
                    }
                    else
                    {
                        textText[j] = temp;
                        j++;
                    }
                }
                
                //textText = readData.Replace("\r", "").Split(new char[] { '\n' });
                

                foreach (string temp in textText)
                {
                    if (temp.Length > textLengthX)
                    {
                        textLengthX = temp.Length;
                    }
                }

                textLengthY = textText.Length;

                showText = true;
            }
            catch
            {
                Game.DisplayText("Can't open " + textTitle[(selectedIndex + selectedPage * itemListY)]);
            }
        }
    }

    void text_KeyDown(object sender, GTA.KeyEventArgs e)
    {

        if (e.Key.ToString().Length == 1)
        {
            input = input.Remove(0, 1) + e.Key.ToString();
        }

        if (textCheck == false)
        {
            if (input == "TEXT")
            {
                input = "####";
                textCheck = true;
                titleLengthX = 0;
                titleLengthX = 0;
                textLengthX = 0;
                textLengthX = 0;
                selectedIndex = 0;
                selectedPage = 0;
                pageNumber = 0;
                showText = false;
                gameKeyPress = false;
                GetItem();
            }
        }
        else
        {
            if (input == "TEXT")
            {
                input = "####";
                textCheck = false;
            }
        }
    }
}